function [y] = globaloptim(x0,Vo_in,qin)
%tic
%qin=[24:-0.25:18]/3600;
%Vo_in=[0.35:0.0125:0.6];
Lsw=1.7;Ro=0.05;Ri=0.025;p2=[Lsw;Ro;Ri];
Lsw_DW=1.7;Ro_DW=0.05;Ri_DW=0.043;p3=[Lsw_DW;Ro_DW;Ri_DW];
p=[qin;Vo_in];
element='l';

x=zeros(length(qin),length(Vo_in),21);
comp=zeros(length(qin),length(Vo_in),6);
exitflag=zeros(length(qin),length(Vo_in));
Cost=zeros(length(qin),length(Vo_in)); 
options =...
    optimset('Algorithm','interior-point','Display','off','MaxIter'...
    ,1e5,'TolX',1e-12,'MaxFunEvals',1e6,'TolCon',1e-5);
A=[];b=[];Aeq=[];beq=[];
 lb=[0.1;0.5;0;0.1;p2(3);zeros(16,1)]; 
        ub=zeros(21,1);
        ub(1:5,1)=[0.9;0.95;p3(3);0.6;p2(2)];
        for k =6:length(ub)
            a=factor(k);
            if a(1)==2; %flow
                ub(k,1)=qin;
            else %volume fraction
                ub(k,1)=1;
            end
        end
teller = 0;
% xopt = zeros(21,2);
% xopt(:,1) = [0.33;0.91;Ri_DW;0.15;Ri;6.7/3600;0.94;13.3/3600;0.13;...
%             6.1/3600;0.98;0.6/3600;0.5;13.9/3600;0.15;2/3600;0.83;...
%             11.9/3600;0.03;8.1/3600;0.94];
% xopt(:,2) = [0.4;0.86;Ri_DW;0.27;Ri;8/3600;0.91;12/3600;0.22;7/3600;...
%             0.97;1/3600;0.48;13/3600;0.24;3.5/3600;0.82;9.5/3600;0.03;...
%             10.5/3600;0.92];
%Optimization
%x01=[Vo_in;0.8;0.4*Ri_DW;0.3;0.65*Ro];
%x02=InitialGuess(x01,p,p2,p3);
exitflag = -2;
while exitflag == -2
        problem = createOptimProblem('fmincon','objective',@(x)CostFunc2(x,p,p2,p3)...
            ,'x0',x0,'lb',lb,'ub',ub,'nonlcon',@(x)constraints2(x,p,p2,p3,element)...
            ,'options',options);
        gs = MultiStart;
        [x,~,exitflag] = run(gs, problem,10);
        teller = teller + 1;
        if teller > 10
            return
        end
end     
y = x;
