
clearvars -except y 
clear all
clc
tic
%xnom = load('xvar.mat');
%xnom = load('xnom2.mat');
%load('xnom20-0.35.mat');
load('xnomadj2.mat')
x1 = x;
qin=[18:0.25:23]/3600;
%qin =[30:-0.25:15]/3600;
%qin= (20/3600);
%Vo_in=0.40;%
Vo_in=[0.35:0.0125:0.6];

%Vo_in = [0.3:0.0125:0.7];
Lsw=1.7;Ro=0.05;Ri=0.025;p2=[Lsw;Ro;Ri];
Lsw_DW=1.7;Ro_DW=0.05;Ri_DW=0.043;p3=[Lsw_DW;Ro_DW;Ri_DW];

element='l';
dotvec = zeros(length(qin),length(Vo_in));
x=zeros(length(qin),length(Vo_in),21);
comp=zeros(length(qin),length(Vo_in),6);
exitflag=zeros(length(qin),length(Vo_in));
Cost=zeros(length(qin),length(Vo_in)); 
options =...
    optimset('Algorithm','interior-point','Display','Off','MaxIter'...
    ,1e5,'TolX',1e-13,'MaxFunEvals',1e6,'TolCon',1e-5);
A=[];b=[];Aeq=[];beq=[];
% xopt = zeros(21,2);
% xopt(:,1) = [0.33;0.91;Ri_DW;0.15;Ri;6.7/3600;0.94;13.3/3600;0.13;...
%             6.1/3600;0.98;0.6/3600;0.5;13.9/3600;0.15;2/3600;0.83;...
%             11.9/3600;0.03;8.1/3600;0.94];
% xopt(:,2) = [0.4;0.86;Ri_DW;0.27;Ri;8/3600;0.91;12/3600;0.22;7/3600;...
%             0.97;1/3600;0.48;13/3600;0.24;3.5/3600;0.82;9.5/3600;0.03;...
%             10.5/3600;0.92];
% grad = zeros(length(qin),length(Vo_in),21);
%Optimization
for j=1:length(Vo_in)
    for i=1:length(qin)
        p=[qin(i);Vo_in(j)];
        % Bounds for inputs
        %The bounadries on the FSs are just to help the solver
        %and should not be active!! 
        lb=[0.2;0.5;0;0.01;p2(3);zeros(16,1)]; 
        %lb=[0;0.5;0;0;p2(3);zeros(16,1)]; 
        ub=zeros(21,1);
        %ub(1:5,1)=[0.9;0.95;p3(3);0.6;p2(2)];
        ub(1:5,1)=[0.999;0.999;p3(3);0.6;p2(2)];
        for k =6:length(ub)
            a=factor(k);
            if a(1)==2; %flow
                ub(k,1)=qin(i);
            else %volume fraction
                ub(k,1)=1;
            end
        end
        % Turn off initial guess and replace with old nominal values
%         if j==1 && i==1
%            x0 = squeeze(xnom);
%             
%        %Initial guess
%        if j==1 && i==1
%             %  FS_g,FS_DW,rin_DW,FS_DO,rin_DO
%             x01=[Vo_in(i);0.8;0.4*Ri_DW;0.3;0.65*Ro];
%             x0=InitialGuess(x01,p,p2,p3);
            toc
%         elseif i==1 && j~=1
%           x0 = squeeze(xnom);
%           
           %x0=x02;
%         else
%             x01=[Vo_in(i);x0(2);x0(3);x0(4);x0(5)];
%             x0=InitialGuess(x01,p,p2,p3);
  %      end
        % Forces guesses to be close to "true" values
%         if Vo_in(j) < 0.45
%             for k = 1:length(x0)
%                 if (x0(k)/xopt(k,1)) > 1.1 || (x0(k)/xopt(k,1)) < 0.9
%                     x0(k) = xopt(k,1);
%                     teller = teller +1;
%                 end
%             end
%         
%         elseif Vo_in(j) >= 0.45
%             for k = 1:length(x0)
%                 if (x0(k)/xopt(k,2)) > 1.1 || (x0(k)/xopt(k,2)) < 0.9
%                     x0(k) = xopt(k,2); 
%                 end
%             end
%         end
        x0 = squeeze(x1(i,j,:));
        [x(i,j,:),~,exitflag(i,j),output(i,j),lambda(i,j)] = fmincon(...
            @(x)CostFunc2(x,p,p2,p3),x0,A,b,Aeq,beq,lb,ub,...
            @(x)constraints2(x,p,p2,p3,element,Vo_in(j)),options);
        [Cost(i,j)]=CostFunc2(x(i,j,:),p,p2,p3);
        if exitflag(i,j)==1 ||exitflag(i,j)==2
            x0=squeeze(x(i,j,:));
        elseif exitflag(i,j) == -2 && j>2
                xold = squeeze(x(i,j-2,:));
                x(i,j-1,:) = globaloptim(xold,Vo_in(j-1),qin(i));
                x(i,j,:) = globaloptim(x0,Vo_in(j),qin(i));
                x0=squeeze(x(i,j,:));
         elseif exitflag(i,j) == -2 && j<=2
                x(i,j,:) = globaloptim(x0,Vo_in(j),qin(i));
                x0=squeeze(x(i,j,:));        
        end
        if j==1
            x02=x0;
        end
        %Define a plot tolerance 1%
        plottol = 0.01*0.99;
        if x0(19)<plottol
            dotvec(i,j) = 1;
        else
            dotvec(i,j) = 0;
        end
    end
end
Cost
y=x(:,:,15);
exitflag
toc
%%
for i=1:length(qin)
for j=1:length(Vo_in)
lambdaplot(i,j)=  lambda(i,j).ineqnonlin(3)
end
end
%% Create constrained scatter
figure(7)
imagesc(Vo_in,qin*3600,lambdaplot)
colormap(gray) 
xlabel('$\alpha_{in}$','Interpreter','latex')
ylabel('$q_{in}$','Interpreter','latex')
title('Active Constraint map','Interpreter','latex');
set(gca,'fontname','CMU Serif')
%matlab2tikz(['../../../Apps/ShareLaTeX/NTNU Masters Thesis/fig/','constraintmap','.tex']);
%% Loss at Optimum
Loss = ((Cost(:,:)-min(min(Cost)))*100)/min(min(Cost));
surf(Vo_in,qin,Loss)
%% Plot
figure(6)
subplot(311);contourf(Vo_in,qin*3600,x(:,:,1))
title('Gravity Tank: Flow Split')
xlabel('$\alpha_{in}$ [-]','Interpreter','latex'); ylabel('$q_{in} [m^3/h]$','Interpreter','latex') %set(gca,'xtick',[])%set(gca,'ytick',[])
set(gca,'fontname','CMU Serif','fontsize',20)

colorbar

% optimal FS
subplot(312);contourf(Vo_in,qin*3600,x(:,:,2))
title('Dewaterer: Flow Split')
xlabel('$\alpha_{in}$ [-]','Interpreter','latex'); ylabel('$q_{in} [m^3/h]$','Interpreter','latex')
set(gca,'fontname','CMU Serif','fontsize',20)
colorbar
% optimal FS
subplot(313);contourf(Vo_in,qin*3600,x(:,:,4))
title('Deoiler: Flow Split')
xlabel('$\alpha_{in}$ [-]','Interpreter','latex'); ylabel('$q_{in} [m^3/h]$','Interpreter','latex')
set(gca,'fontname','CMU Serif','fontsize',20)
colorbar
%matlab2tikz(['../../../Apps/ShareLaTeX/NTNU Masters Thesis/fig/steadystateresults.tikz']);
%% Vo_in Effect on inlet oil cut
co=lines;
figure(1)
plot(Vo_in,x(end,:,1),'Color',co(1,:),'Linewidth',2);hold on
plot(Vo_in,x(end,:,2),'Color',co(2,:),'Linewidth',2)
plot(Vo_in,x(end,:,4),'Color',co(4,:),'Linewidth',2)
xlabel('$\alpha_{in}$ [-]','Interpreter','latex');
ylabel('$\vec{FS}^{opt}$ [-]','Interpreter','latex');
legend('$FS_G$','$FS_{DW}$','$FS_{DO}$')
figure(2)
plot(Vo_in,x(end,:,21),'Color',co(1,:),'Linewidth',2)
ax = gca;
set(ax,'fontsize',14,'TickLabelInterpreter', 'latex');
xlabel('$\alpha_{in}$ [-]','fontsize',14,'Interpreter','latex');
ylabel('$\alpha_{L,Prod}$ [-]','fontsize',14,'Interpreter','latex')
%matlab2tikz(['../../../Apps/ShareLaTeX/NTNU Masters Thesis/fig/alphalprod.tikz']);
figure(3)
plot(Vo_in,x(end,:,19),'Color',co(1,:),'Linewidth',2)
ax = gca;
set(ax,'fontsize',14,'TickLabelInterpreter', 'latex');
xlabel('$\alpha_{in}$ [-]','fontsize',14,'Interpreter','latex');
ylabel('$\alpha_{H,Prod}$ [-]','fontsize',14,'Interpreter','latex')
%matlab2tikz(['../../../Apps/ShareLaTeX/NTNU Masters Thesis/fig/alphahprod.tikz']);
%matlab2tikz('alphahprod.tikz');
%%
co=lines;
figure(2)
hold on
plot(Vo_in,x(1,:,21),'Color',co(2,:),'Linewidth',2)
leg1 = legend('$\vec{FS}^{opt}$','$\vec{FS}^{fixed}$');
set(leg1, 'Interpreter','latex')
figure(3)
hold on
plot(Vo_in,x(1,:,19),'Color',co(2,:),'Linewidth',2)
leg2 = legend('$\vec{FS}^{opt}$','$\vec{FS}^{fixed}$');
set(leg2, 'Interpreter','latex')
%% qin Effect on flow rate, 
co=lines;
figure(1)
plot(qin'*3600,x(:,1,1),'Color',co(1,:),'Linewidth',2);hold on
plot(qin'*3600,x(:,1,2),'Color',co(2,:),'Linewidth',2)
plot(qin'*3600,x(:,1,4),'Color',co(4,:),'Linewidth',2)
xlabel('$q_{in}$ [-]','Interpreter','latex');ylabel('$\vec{FS}^{opt}$ [-]','Interpreter','latex');
axis([18 24 0 1]);
legend('$FS_G$','$FS_{DW}$','$FS_{DO}$')
%FS opt
figure(2)
plot(qin'*3600,x(:,1,21),'Color',co(1,:),'Linewidth',2)
axis([18 24 0 1]);
xlabel('$q_{in}$ [-]','Interpreter','latex'),ylabel('$\alpha_{L,Prod}$ [-]','Interpreter','latex')
matlab2tikz(['../../../Apps/ShareLaTeX/NTNU Masters Thesis/fig/alphalprod.tikz']);
figure(3)
axis([18 24 0 1]);
plot(qin'*3600,x(:,1,19),'Color',co(1,:),'Linewidth',2)
xlabel('$q_{in}$ [-]','Interpreter','latex'),ylabel('$\alpha_{H,Prod}$ [-]','Interpreter','latex')
matlab2tikz(['../../../Apps/ShareLaTeX/NTNU Masters Thesis/fig/alphahprod.tikz']);
%% FS fixed
co=lines;
figure(2)
hold on
plot(qin'*3600,x(:,1,21),'Color',co(2,:),'Linewidth',2)
leg3 = legend('$\vec{FS}^{opt}$','$\vec{FS}^{fixed}$');
set(leg3, 'Interpreter','latex')
figure(3)
hold on
plot(qin'*3600,x(:,1,19),'Color',co(2,:),'Linewidth',2)
leg4 = legend('$\vec{FS}^{opt}$','$\vec{FS}^{fixed}$');
set(leg4, 'Interpreter','latex')
%% Checking smooth vt function
%uncomment vt in swirl_sep2_o. Set vt as output.
r=0:0.00001:Ro;
for i=1:length(r);
    in=[10/3600;Ro_DW;Ri_DW;0.8;4;r(i);0.8];
    vt(i)=swirl_sep2_o(0,r(i),in,element);
end
figure(2);hold on; plot(r,vt)