function DXDT=swirl_sep2(t,x,in,element)
%deoiler
qin=in(1);
Ro=in(2);
Ri=in(3);
Vo_in=in(4);
ta=in(5);
rin=in(6);
FS=in(7);

rhoo=881;%872; %kg/m^3
rhow=1064;

r=x(1);

Rc=0.25*Ro;
va=qin/(pi*Ro^2);
if element=='w' %weak
    k=3.5;
elseif element=='s' %strong
    k=5;
elseif element=='l' %large
    k=7;
end

vt=k*va;

%Experimental correlation between rd and vt
% if vt>4.45%28
%     rd=(-8*vt+160)/2*10^-6;
% else
%     rd=(-107*vt+600)/2*10^-6;
% end
rd= (-107*vt+600)/2*10^-6+0.5*(1+tanh(10000*(vt-4.45)))...
    *(((-8*vt+160)/2*10^-6)-(-107*vt+600)/2*10^-6);
%   if vt>4%28
%      rd=10^-6*(80-4*vt);
%     
%  else
%     rd=10^-6*(300-59*vt);
% 
%  end
%   if vt>0.2%28
%      rd=0.0014*vt^(-1.244);
%     
%  else
%     rd=-0.0645*vt+ 0.0233;
% 
%  end

va=qin*(1-FS)/(pi*(Ro^2-Ri^2));
%rd=(-8*vt+160)/2*10^-6;

% if qin>50/3600
%     rd=30*10^-6;
% else
%     rd=50*10^-6;
% end

%diameter=2*rd*10^6
Vo_c=Vo_in*(FS*(Ro^2-Ri^2)*(Ro^2-r^2)+(rin^2-Ri^2)*(Ro^2-r^2)*(1-FS))...
    /((r^2-Ri^2)*(Ro^2-r^2)*(1-FS)+FS*(Ro^2-Ri^2)*(Ro^2-r^2));

mum=(0.6*Vo_c^3-0.506*Vo_c^2+0.137*Vo_c+0.001);
%mum=(0.47*Vo_c^3-0.4*Vo_c^2+0.11*Vo_c+0.001);

vr=((2/9*(rhoo-rhow)*rd^2/(mum)...
    *(vt*exp(-0.04*va*t/(2*Ro)))^2/r)*heaviside(r-Rc)... %r>Rc
    +(2/9*(rhoo-rhow)*rd^2/mum...
    *r*(vt*exp(-0.04*va*t/(2*Ro))/Rc)^2)*heaviside(Rc-r))...; %r<Rc
    *heaviside(r-0.9*Ri); %To make sure r>0

drdt=vr;

DXDT=[drdt];
end