function [Vo_LPO,Vo_HPO,qen]=DeOiler(qin,Vo_in,FS,rin,p2)
Ro=p2(2);Ri=p2(3);

qi=FS*qin; qo=qin-qi;

Vo_LPO=Vo_in*(FS*(Ro^2-Ri^2)+(rin^2-Ri^2)*(1-FS))...
    /(FS*(Ro^2-Ri^2));
Vo_HPO=(Vo_in*qin-Vo_LPO*qi)/qo;
u_HPO=qo/(pi*(Ro^2-Ri^2));u_LPO=qi/(pi*Ri^2);

du=(u_LPO-u_HPO);

k=2*10^-4;
%k=0;
qen=k*du;
if du>=0
    Vo_LPO=(Vo_LPO*(qi-qen)+Vo_HPO*qen)/qi;
else
    Vo_HPO=(Vo_HPO*(qo+qen)-Vo_LPO*qen)/qo;
    Vo_LPO=(Vo_in*qin-Vo_HPO*qo)/qi;
end

% k=5*10^-4;
% if du>=0
%     qen=k*du^2;
%     Vo_LPO=(Vo_LPO*(qi-qen)+Vo_HPO*qen)/qi;
% else
%     qen=-k*du^2;
%     Vo_HPO=(Vo_HPO*(qo+qen)-Vo_LPO*qen)/qo;
%     Vo_LPO=(Vo_in*qin-Vo_HPO*qo)/qi;
% end

if Vo_LPO>1
    Vo_LPO=1;
elseif Vo_LPO<Vo_in
    Vo_LPO=Vo_in;
end

Vo_HPO=(Vo_in*qin-Vo_LPO*qi)/qo;
end