function [t,y]=shooting(ODEfile,tspan,h,yf,gamma0,rho,tol,varargin)

gammanew=gamma0;
iter=0;
maxiter=100;
fnk=10*yf;
while max(abs(yf-fnk))>tol & iter<maxiter
    iter=iter+1;
    gamma1=gammanew;
    %Specific for swirl_sep2/Swirl_sep2_o: in(6)=rin
    varargin{1}(6)=gamma1; 
    [t,y]=RK2(ODEfile,tspan,gamma1,h,varargin{:});
    fnk=y(end,1);
        if gamma1~=0
            dgamma=-gamma1/100;
        else
            dgamma=-0.01;
        end
    a=gamma1+dgamma;
    %Specific for swirl_sep2/Swirl_sep2_o: in(6)=rin
    varargin{1}(6)=a;
    [ta,ya]=RK2(ODEfile,tspan,a,h,varargin{:});
    fnka=ya(end,1);
    jacob=(fnka-fnk)/dgamma;
    a=gamma1-dgamma;
    if jacob==0;
        gammanew=gamma1+max([abs(dgamma),1.1*tol]);
    else
        gammanew=gamma1-rho*inv(jacob)*(fnk-yf);
    end
end

if iter>=maxiter
    disp(['Maximum iterations reached. (rout-Ri)/Ri= ',num2str((fnk-yf)/yf)])
    disp(ODEfile)
end
end